주요 콘텐츠로 건너뛰기

Vue와의 통합

이 가이드는 Vue의 개념과 패턴에 익숙하다고 가정합니다. 배경 지식은 Vue 3 문서를 참고하세요.

DHTMLX Kanban은 Vue와 호환됩니다. Vue 3에 대한 전체 코드 예제는 GitHub에서 확인할 수 있습니다.

프로젝트 생성

정보

프로젝트를 생성하기 전에 Node.js를 설치하세요.

다음 명령어로 새 Vue 프로젝트를 생성합니다:

npm create vue@latest

이 명령어는 공식 Vue 프로젝트 스캐폴딩 툴인 create-vue를 실행합니다. 자세한 내용은 Vue.js 빠른 시작을 참고하세요.

프로젝트 이름은 my-vue-kanban-app으로 지정합니다.

의존성 설치

앱 디렉토리로 이동하세요:

cd my-vue-kanban-app

패키지 매니저 중 하나로 의존성을 설치하고 개발 서버를 시작하세요:

yarn
yarn start // 또는 yarn dev
  • npm의 경우:
npm install
npm run dev

앱은 로컬호스트 주소(예: http://localhost:3000)에서 실행됩니다.

Kanban 생성

개발 서버를 중지하고 Kanban 패키지를 설치하세요.

1단계. 패키지 설치

평가판 Kanban 패키지를 다운로드하고 README 파일의 단계를 따르세요. 평가판은 30일간 사용 가능합니다.

2단계. 컴포넌트 생성

Kanban과 Toolbar를 마운트하는 Vue 컴포넌트를 생성합니다. src/components/ 디렉토리에 Kanban.vue 파일을 새로 추가하세요.

소스 파일 가져오기

Kanban.vue를 열고 Kanban 소스 파일을 import 하세요. import 경로는 패키지 버전에 따라 다릅니다:

  • 로컬 폴더에서 설치한 PRO 버전의 경우:
Kanban.vue
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

패키지에 minified 소스 파일이 포함된 경우, CSS 파일을 kanban.min.css로 import 하세요.

  • 평가판의 경우:
Kanban.vue
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

이 튜토리얼에서는 Kanban 평가판을 사용합니다.

컨테이너 설정 및 Kanban 초기화

Kanban과 Toolbar를 표시하려면 두 개의 컨테이너를 생성하고 생성자를 호출하세요. 다음 코드는 refs를 연결하고 mounted() 내부에서 컴포넌트를 인스턴스화합니다:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
mounted() {
// initialize the Kanban component
this.kanban = new Kanban(this.$refs.kanban_container, {});

// initialize the Toolbar component
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api, // provide Kanban inner API
// other configuration properties
});
},

unmounted() {
this.kanban.destructor(); // destroy Kanban
this.toolbar.destructor(); // destroy Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

스타일 추가

메인 CSS 파일에 Kanban과 컨테이너에 대한 스타일을 추가하세요:

main.css
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

데이터 로딩

Kanban에 데이터를 채우려면 데이터셋을 제공하세요. src/ 디렉토리에 data.js 파일을 생성하세요:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

App.vue를 열고 데이터셋을 import 하세요. 내부 data() 메서드를 통해 값을 초기화한 후, 새 <Kanban/> 컴포넌트에 props로 전달하세요:

App.vue
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";

export default {
components: { Kanban },
data() {
const { columns, cards, rows } = getData();
return {
columns,
cards,
rows
};
}
};
</script>

<template>
<Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>

Kanban.vue를 열고 props를 Kanban 설정 객체에 적용하세요:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
cards: this.cards,
columns: this.columns,
rows: this.rows,
rowKey: "type",
// other configuration properties
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// other configuration properties
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

또는 mounted() 내부에서 setConfig() 또는 parse()를 사용해 인스턴스 생성 후 데이터를 로드할 수 있습니다:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// other configuration properties
});

this.kanban.setConfig({
cards: this.cards,
columns: this.columns,
rows: this.rows
});

},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

이제 Kanban 컴포넌트 준비가 완료되었습니다. 요소가 렌더링되면 Kanban이 데이터와 함께 초기화됩니다. 지원되는 설정 속성의 전체 목록은 Kanban API 레퍼런스를 참고하세요.

이벤트 처리

Kanban에서의 사용자 동작은 이벤트를 발생시킵니다. 이벤트를 수신해 특정 동작에 반응하세요. 전체 목록은 Kanban 이벤트 레퍼런스를 참고하세요.

Kanban.vue를 열고 mounted() 메서드를 다음과 같이 확장하세요:

Kanban.vue
<script>
// ...
export default {
// ...
mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {});

this.kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
},

unmounted() {
this.kanban.destructor();
}
}
</script>

// ...

앱을 실행하면 페이지에 데이터가 채워진 Kanban 보드를 확인할 수 있습니다.

Kanban with Vue

완성된 프로젝트는 GitHub에서 확인할 수 있습니다.

주요 콘텐츠로 건너뛰기

React와의 통합

이 가이드는 React의 개념과 패턴에 익숙하다는 것을 전제로 합니다. 배경 지식이 필요하다면 React 문서를 참고하세요.

DHTMLX Kanban은 React와 호환됩니다. 전체 코드 예제는 GitHub에서 확인할 수 있습니다.

프로젝트 생성

정보

프로젝트를 만들기 전에 Vite (선택 사항)와 Node.js를 설치하세요.

기본 React 프로젝트(또는 Vite와 함께 React)를 생성하세요. 프로젝트 이름은 my-react-kanban-app으로 지정합니다:

npx create-react-app my-react-kanban-app

의존성 설치

새로 생성된 앱 디렉터리로 이동합니다:

cd my-react-kanban-app

패키지 매니저 중 하나를 사용하여 의존성을 설치하고 개발 서버를 시작하세요:

yarn
yarn start
  • npm의 경우:
npm install
npm run dev

앱이 로컬호스트 주소(예: http://localhost:3000)에서 실행됩니다.

Kanban 생성

개발 서버를 중지하고 Kanban 패키지를 설치하세요.

1단계. 패키지 설치

평가판 Kanban 패키지를 다운로드하고 README 파일의 지침을 따르세요. 평가판은 30일 동안 사용할 수 있습니다.

2단계. 컴포넌트 생성

애플리케이션에 Kanban을 추가하는 React 컴포넌트를 생성하세요. src/ 디렉터리에 새 파일을 추가하고 이름을 Kanban.jsx로 지정하세요.

소스 파일 가져오기

Kanban.jsx를 열고 Kanban 소스 파일을 import 하세요. import 경로는 패키지 버전에 따라 다릅니다:

  • 로컬 폴더에서 설치한 PRO 버전의 경우:
Kanban.jsx
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';

패키지에 minify된 소스 파일이 포함된 경우, CSS 파일을 kanban.min.css로 import하세요.

  • 평가판의 경우:
Kanban.jsx
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";

이 튜토리얼에서는 Kanban 평가판을 사용합니다.

컨테이너 설정 및 Kanban 초기화

Kanban과 Toolbar를 표시하려면 두 개의 컨테이너를 만들고 생성자를 호출하세요. 다음 코드 스니펫은 ref를 연결하고 useEffect() 내에서 컴포넌트를 인스턴스화합니다:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // include Kanban styles

export default function KanbanComponent(props) {
let toolbar_container = useRef(); // initialize container for Toolbar
let kanban_container = useRef(); // initialize container for Kanban

useEffect(() => {
// initialize the Kanban component
const kanban = new Kanban(kanban_container.current, {});

// initialize the Toolbar component
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
});

return () => {
kanban.destructor(); // destroy Kanban
toolbar.destructor(); // destroy Toolbar
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

스타일 추가

메인 CSS 파일에 Kanban과 컨테이너에 대한 스타일을 추가하세요:

index.css
/* specify styles for initial page */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

데이터 로딩

Kanban에 데이터를 채우려면 데이터 셋을 제공하세요. src/ 디렉터리에 data.js 파일을 생성하세요:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

App.js를 열고 데이터 셋을 import 한 뒤, 새 <Kanban/> 컴포넌트에 props로 값을 전달하세요:

App.js
import Kanban from "./Kanban";
import { getData } from "./data";

function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}

export default App;

Kanban.jsx를 열고 props를 Kanban 설정 객체에 적용하세요:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // apply column data
cards: props.cards, // apply card data
rows: props.rows, // apply row data
rowKey: "type",
// other configuration properties
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// other configuration properties
});

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

또는 인스턴스 생성 후 useEffect() 내에서 setConfig() 또는 parse()로 데이터를 로드할 수 있습니다:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

let columns = props.columns;
let cards = props.cards;
let rows = props.rows;

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// other configuration properties
});

kanban.setConfig({ columns, cards, rows });
// or kanban.parse({ columns, cards, rows });

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

이제 Kanban 컴포넌트가 준비되었습니다. 요소가 렌더링되면 Kanban이 데이터와 함께 초기화됩니다. 지원되는 설정 속성의 전체 목록은 Kanban API 레퍼런스를 참고하세요.

이벤트 처리

Kanban에서 사용자 동작이 발생하면 이벤트가 트리거됩니다. 이벤트를 수신하여 특정 동작에 반응할 수 있습니다. 전체 목록은 Kanban 이벤트 레퍼런스를 참고하세요.

Kanban.jsx를 열고 useEffect() 호출을 확장하세요:

Kanban.jsx
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});

return () => {
kanban.destructor();
};
}, []);
// ...

앱을 실행하여 페이지에 Kanban 보드가 데이터와 함께 표시되는지 확인하세요.

Kanban with React

완성된 프로젝트는 GitHub에서 확인하세요.

주요 콘텐츠로 건너뛰기

Svelte와의 통합

이 가이드는 Svelte의 개념과 패턴에 익숙하다고 가정합니다. 기본 내용은 Svelte documentation을 참고하세요.

DHTMLX Kanban은 Svelte와 호환됩니다. 전체 코드 예제는 GitHub에서 확인할 수 있습니다.

프로젝트 생성

정보

프로젝트를 만들기 전에 Vite (선택 사항)와 Node.js를 설치하세요.

Svelte 프로젝트를 만드는 방법은 두 가지입니다:

  • SvelteKit 사용 — 권장
  • Svelte와 Vite 사용(SvelteKit 없이) — 다음 명령어를 실행합니다:
npm create vite@latest

자세한 내용은 Svelte documentation을 참고하세요.

의존성 설치

프로젝트 이름을 my-svelte-kanban-app으로 지정합니다. 앱 디렉터리로 이동합니다:

cd my-svelte-kanban-app

패키지 매니저 중 하나를 사용해 의존성을 설치하고 개발 서버를 실행하세요:

yarn
yarn start
  • npm의 경우:
npm install
npm run dev

앱은 localhost 주소에서 실행됩니다(예: http://localhost:3000).

Kanban 생성

개발 서버를 중지하고 Kanban 패키지를 설치하세요.

1단계. 패키지 설치

trial Kanban package를 다운로드하고 README 파일의 단계를 따르세요. trial 버전은 30일 동안 사용할 수 있습니다.

2단계. 컴포넌트 생성

Kanban과 Toolbar를 마운트하는 Svelte 컴포넌트를 만듭니다. src/ 디렉터리에 새 Kanban.svelte 파일을 추가하세요.

소스 파일 가져오기

Kanban.svelte 파일을 열고 Kanban 소스 파일을 import 합니다. import 경로는 패키지 버전에 따라 다릅니다:

  • 로컬 폴더에서 설치한 PRO 버전의 경우:
Kanban.svelte
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

패키지에 minified 소스 파일이 포함된 경우 CSS 파일을 kanban.min.css로 import 하세요.

  • trial 버전의 경우:
Kanban.svelte
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

이 튜토리얼은 trial 버전의 Kanban을 사용합니다.

컨테이너 설정 및 Kanban 초기화

Toolbar와 함께 Kanban을 표시하려면 두 개의 컨테이너를 만들고 생성자를 호출합니다. 다음 코드 스니펫은 컨테이너를 바인딩하고 onMount() 내에서 컴포넌트를 인스턴스화합니다:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

let toolbar_container, kanban_container; // initialize containers for Kanban and Toolbar
let kanban, toolbar;

onMount(() => {
// initialize the Kanban component
kanban = new Kanban(kanban_container, {})

// initialize the Toolbar component
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})
});

onDestroy(() => {
kanban.destructor(); // destroy Kanban
toolbar.destructor(); // destroy Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

데이터 로딩

Kanban에 데이터를 채우려면 데이터 세트를 제공하세요. src/ 디렉터리에 data.js 파일을 만듭니다:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

App.svelte 파일을 열고 데이터 세트를 import하여 새 <Kanban/> 컴포넌트에 props로 전달하세요:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { cards, columns, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Kanban.svelte 파일을 열고 props를 Kanban 설정 객체에 적용하세요:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// other configuration properties
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

또는 인스턴스를 생성한 후 onMount() 내에서 setConfig() 또는 parse()를 사용해 데이터를 로드할 수 있습니다:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
})

kanban.setConfig({ columns, cards, rows });
// or kanban.parse({ columns, cards, rows });
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

이제 Kanban 컴포넌트가 준비되었습니다. 요소가 렌더링되면 Kanban이 데이터와 함께 초기화됩니다. 지원되는 전체 설정 속성 목록은 Kanban API 레퍼런스를 참고하세요.

이벤트 처리

Kanban에서 사용자 작업이 발생하면 이벤트가 트리거됩니다. 이벤트를 수신하여 특정 작업에 반응할 수 있습니다. 전체 목록은 Kanban 이벤트 레퍼런스를 참고하세요.

Kanban.svelte 파일을 열고 onMount() 콜백을 확장하세요:

Kanban.svelte
<script>
// ...
let kanban;

onMount(() => {
kanban = new Kanban(kanban_container, {})

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});

onDestroy(() => {
kanban.destructor();
});
</script>

// ...

3단계. Kanban을 앱에 추가

컴포넌트를 등록하려면 App.svelte 파일을 열고 기본 코드를 교체하세요:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { columns, cards, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

앱을 실행하면 Kanban 보드가 데이터와 함께 페이지에 표시됩니다.

Kanban with Svelte

전체 프로젝트는 GitHub에서 확인하세요.

주요 콘텐츠로 건너뛰기

Angular와의 통합

이 가이드는 Angular의 개념과 패턴에 익숙하다고 가정합니다. 기본 내용은 Angular documentation을 참고하세요.

DHTMLX Kanban은 Angular와 호환됩니다. 전체 코드 예제는 GitHub에서 확인할 수 있습니다.

프로젝트 생성

정보

프로젝트를 생성하기 전에 Angular CLINode.js를 설치하세요.

아래 명령어를 실행하면 Angular CLI로 새 my-angular-kanban-app 프로젝트가 생성됩니다:

ng new my-angular-kanban-app
노트

이 가이드를 따르려면, 새 Angular 앱을 생성할 때 서버 사이드 렌더링(SSR)과 정적 사이트 생성(SSG/Prerendering)을 비활성화하세요!

위 명령어는 필요한 모든 도구를 설치합니다. 추가 명령어를 실행할 필요가 없습니다.

의존성 설치

새로 생성한 앱 디렉토리로 이동하세요:

cd my-angular-kanban-app

yarn 패키지 관리자로 의존성을 설치하고 개발 서버를 시작하세요:

yarn
yarn start

앱은 로컬호스트 주소(예: http://localhost:3000)에서 실행됩니다.

Kanban 생성

개발 서버를 중지하고 Kanban 패키지를 설치하세요.

1단계. 패키지 설치

평가판 Kanban 패키지를 다운로드하고, README 파일에 안내된 단계를 따르세요. 평가판 Kanban은 30일간만 사용 가능합니다.

2단계. 컴포넌트 생성

Kanban과 Toolbar를 마운트하는 Angular 컴포넌트를 생성하세요. src/app/kanban/ 폴더를 만들고 그 안에 kanban.component.ts 파일을 추가하세요.

소스 파일 임포트

kanban.component.ts 파일을 열고 Kanban 소스 파일을 임포트하세요. 임포트 경로는 패키지 버전에 따라 다릅니다:

  • 로컬 폴더에서 설치한 PRO 버전의 경우:
import { Kanban, Toolbar } from 'dhx-kanban-package';
  • 평가판 버전의 경우:
import { Kanban, Toolbar } from '@dhx/trial-kanban';

이 튜토리얼에서는 평가판 Kanban을 사용합니다.

컨테이너 설정 및 Kanban 초기화

Toolbar와 함께 Kanban을 표시하려면 두 개의 컨테이너를 설정하고 생성자를 호출하세요. 아래 코드 스니펫은 컴포넌트 템플릿을 정의하고, 컨테이너를 참조하며, 인스턴스를 생성합니다:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // "app.component.ts" 파일에서 <kanban /> 형태로 사용하는 템플릿 이름
styleUrls: ["./kanban.component.css"], // css 파일 포함
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
// Toolbar 컨테이너 초기화
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// Kanban 컨테이너 초기화
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
// Kanban 컴포넌트 초기화
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

// Toolbar 컴포넌트 초기화
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 기타 구성 속성
});
}

ngOnDestroy(): void {
this._kanban.destructor(); // Kanban 파괴
this._toolbar.destructor(); // Toolbar 파괴
}
}

스타일 추가

Kanban과 컨테이너에 스타일을 추가하세요. src/app/kanban/ 디렉토리에 kanban.component.css 파일을 생성하세요:

kanban.component.css
/* Kanban 스타일 임포트 */
@import "@dhx/trial-kanban/dist/kanban.css";

/* 초기 페이지 스타일 지정 */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}

/* Kanban 및 Toolbar 컨테이너 스타일 */
.component_container {
height: 100%;
margin: 0 auto;
}

/* Kanban 컨테이너 스타일 */
.widget {
height: calc(100% - 56px);
}

데이터 로딩

Kanban에 데이터를 채우려면 데이터 세트를 제공하세요. src/app/kanban/ 디렉토리에 data.ts 파일을 생성하세요:

data.ts
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

kanban.component.ts 파일을 열고 데이터 세트를 임포트한 다음, ngOnInit() 내부의 Kanban 설정 객체에 데이터 속성을 전달하세요:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 데이터 임포트
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // 데이터 속성 초기화
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // 컬럼 데이터 적용
cards, // 카드 데이터 적용
rows, // 행 데이터 적용
rowKey: "type",
// 기타 구성 속성
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 기타 구성 속성
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

또는 ngOnInit() 내부에서 인스턴스 생성 후 setConfig() 또는 parse()를 사용하여 데이터를 로드할 수 있습니다:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // 데이터 임포트
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // 데이터 속성 초기화
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// 기타 구성 속성
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// 기타 구성 속성
});

// setConfig() 또는 parse() 메서드로 데이터 적용
this._kanban.setConfig({
columns,
cards,
rows
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

이제 Kanban 컴포넌트를 사용할 준비가 되었습니다. 요소가 렌더링되면 데이터와 함께 Kanban이 초기화됩니다. 지원되는 전체 구성 속성 목록은 Kanban API 레퍼런스를 참고하세요.

이벤트 처리

Kanban에서 사용자 동작이 발생하면 이벤트가 트리거됩니다. 이벤트를 수신하여 특정 동작에 반응할 수 있습니다. 전체 목록은 Kanban 이벤트 레퍼런스를 참고하세요.

kanban.component.ts 파일을 열고 ngOnInit() 메서드를 확장하세요:

kanban.component.ts
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}

ngOnDestroy(): void {
this._kanban.destructor();
}

3단계. Kanban을 앱에 추가

앱에 KanbanComponent를 등록하려면 src/app/app.component.ts 파일을 열고 기본 코드를 교체하세요:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}

src/app/ 디렉토리에 app.module.ts 파일을 생성하고 KanbanComponent를 선언하세요:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";

@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

src/main.ts 파일을 열고 기존 코드를 교체하세요:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

앱을 실행하면 페이지에 데이터가 채워진 Kanban 보드가 표시됩니다.

Kanban with Angular

전체 프로젝트는 GitHub에서 확인할 수 있습니다.